﻿using Styx.Plugins;
using Styx.WoWInternals;
using Styx.CommonBot;
using Styx.Common;
using System;
using System.IO;
using System.Collections.Generic;
using System.Timers;
using System.Text.RegularExpressions;
using System.Collections;

namespace BuddyCon
{
    public class BuddyCon : HBPlugin
    {
        

        Timer times = new Timer();

        public override string Author
        {
            get { return "thalord"; }
        }

        public override string Name
        {
            get { return "BuddyCon"; }
        }

        public override void Pulse() { }

        public override System.Version Version
        {
            get { return new System.Version(1, 0, 44); }
        }

 

        public override void OnButtonPress()
        {
            new FormSettings().ShowDialog();

        }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "Settings"; } }
        public override void Initialize()
        {
            Logging.Write(string.Format("[bC]: Version {0} initalized", Version.ToString()));
        }


        public override void Dispose()
        {
            base.Dispose();
            Chat.Say -= Chat_Say;
            Chat.Yell -= Chat_Yell;
            Chat.Whisper -= Chat_Whisper;
            Chat.Party -= Chat_Party;
            Chat.PartyLeader -= Chat_Party;
            Chat.Guild -= Chat_Guild;
            Chat.Emote -= Chat_Emote;
            Chat.Battleground -= Chat_BG;
            Chat.BattlegroundLeader -= Chat_BG;
            Chat.Raid -= Chat_Raid;
            Chat.RaidLeader -= Chat_Raid;

            Styx.CommonBot.BotEvents.Player.OnPlayerDied -= onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp -= onLevel;

            Styx.CommonBot.BotEvents.OnBotStopped -= onStop;
            Styx.CommonBot.BotEvents.OnBotStarted -= onStart;

            Lua.Events.DetachEvent("CHAT_MSG_MONEY", Loot);
            Lua.Events.DetachEvent("CHAT_MSG_COMBAT_XP_GAIN", Xp);
            Lua.Events.DetachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);

            Logging.Write("[bC]: Dispose ");

            
            times.Elapsed -= new ElapsedEventHandler(updater);
            times.Enabled = false;

        }


        private Dictionary<string, string> data = new Dictionary<string, string>();

        private Dictionary<string, string> status = new Dictionary<string, string>();


        public BuddyCon()
        {
            Chat.Say += Chat_Say;
            Chat.Yell += Chat_Yell;
            Chat.Whisper += Chat_Whisper;
            Chat.Party += Chat_Party;
            Chat.PartyLeader += Chat_Party;
            Chat.Guild += Chat_Guild;
            Chat.Emote += Chat_Emote;
            Chat.Battleground += Chat_BG;
            Chat.BattlegroundLeader += Chat_BG;
            Chat.Raid += Chat_Raid;
            Chat.RaidLeader += Chat_Raid;

            Styx.CommonBot.BotEvents.Player.OnPlayerDied += onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp += onLevel;

            Styx.CommonBot.BotEvents.OnBotStopped += onStop;
            Styx.CommonBot.BotEvents.OnBotStarted += onStart;

            Lua.Events.AttachEvent("CHAT_MSG_MONEY", Loot);
            Lua.Events.AttachEvent("CHAT_MSG_COMBAT_XP_GAIN", Xp);

            data.Add("version", Version.ToString());
            data.Add("name", "");
            data.Add("level", "");
            data.Add("xp", "");
            data.Add("xp_needed", "");
            data.Add("chat_message", "");
            data.Add("chat_type", "");
            data.Add("chat_from", "");
            data.Add("screen", "");
            data.Add("nodeh", "");
            data.Add("runningtime", "");

            // setup timer to send updates
            times.Elapsed += new ElapsedEventHandler(updater);
            times.Interval = 9000;
            times.Enabled = true;
        }

        private void onStart(EventArgs args)
        {
            Logging.Write("[bC]: Bot started");

            Util.sendToProwl("Bot", "Bot started");

            status.Add("message", "Bot started");
            send(data);

        }

        private void onStop(EventArgs args)
        {
            Logging.Write("[bC]: Bot stopped");

            Util.sendToProwl("Bot", "Bot stopped");

            status.Add("message", "Bot stopped");
            send(data);

        }

        private void onDead()
        {
            Logging.Write("[bC]: Died!");
        
            Util.sendToProwl("Died", "Died");

            status.Add("message", "Died!");
            if (BuddyConSettings.Instance.scDied) screenie();

        }

        private void onLevel(BotEvents.Player.LevelUpEventArgs args)
        {
            Logging.Write("[bC]: Level up!");

            Util.sendToProwl("Level", "Level up");

            status.Add("message", "Level up!");
            if (BuddyConSettings.Instance.scLevel) screenie();
        }

        private void uploadscreen(object sender, LuaEventArgs args)
        {
            Lua.Events.DetachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);
            //Logging.Write(string.Format("[bC]: Screenshot Version {0}", Version.ToString()));
            //Logging.Write("[bC]: Screenshot upload");
            var directory = new DirectoryInfo(BuddyConSettings.Instance.wowdir + "\\Screenshots\\");
            string ret = "";
            if(BuddyConSettings.Instance.scripturl != "")
                ret = Util.PostToFtp(directory + Util.GetLatestWritenFileFileInDirectory(directory).ToString());
            else
                ret = Util.PostToImgur(directory + Util.GetLatestWritenFileFileInDirectory(directory).ToString(), "e6b704a473bc5894e03ff99db649e825");

            data["screen"] = ret;
            status.Add("message", "Screenshot sent");
            Logging.Write("[bC]: Screenshot sent");
            send(data); 

        }

        private void updater(object sender, ElapsedEventArgs e)
        {
            send(data);
        }

        private void Loot(object sender, LuaEventArgs args)
        {
            //status.Add("message", string.Format("Loot: {0}", args.Args[0]));
            //Logging.Write(string.Format("[bC]: Loot: {0}", args.Args[0]));

        }
        private void Xp(object sender, LuaEventArgs args)
        {
            // Logging.Write(string.Format("[bC]: Xp: {0}", args.Args[0]));
            Regex r = new Regex("(\\d)+");
            MatchCollection mc = r.Matches(args.Args[0].ToString());
            status.Add("message", string.Format("Xp gain: {0}", mc[0].ToString()));

        }

        #region Chat
        private void Chatter(string message, string author = "", string type = "")
        {
            Util.sendToProwl("Chat", string.Format("[bC]: Chat: From: {1}  Message: {0} Type: {2}", message, author, type));
            Logging.Write(string.Format("[bC]: Chat: From: {1}  Message: {0} Type: {2}", message, author, type));
            data["chat_message"] = message;
            data["chat_type"] = type;
            data["chat_from"] = author;
            if (BuddyConSettings.Instance.scChat) screenie();
            send(data);
        }
        private void Chat_Raid(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_BG(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Emote(Styx.CommonBot.Chat.ChatAuthoredEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Party(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Whisper(Styx.CommonBot.Chat.ChatWhisperEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Yell(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Say(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_Guild(Styx.CommonBot.Chat.ChatGuildEventArgs e)
        {
            Chatter(e.Message, e.Author, e.EventName);
        }
        #endregion

        
        private void screenie()
        {
            Logging.Write("[bC]: Screenshot requested");
            Lua.Events.AttachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);
            Lua.DoString("TakeScreenshot()");
        }
        private void send(Dictionary<string, string> data)
        {
            if (Convert.ToInt32(Styx.StyxWoW.Me.Level) < 0 || Convert.ToInt32(Styx.StyxWoW.Me.Level) > 91) return;
            if (Convert.ToInt32(Styx.StyxWoW.Me.Experience) < 0 || Convert.ToInt32(Styx.StyxWoW.Me.Experience) >= Int32.MaxValue) return;
            if (Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience) < 0 || Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience) >= Int32.MaxValue) return;
            if (Convert.ToInt32(Styx.StyxWoW.Me.Copper) < 0 || Convert.ToInt32(Styx.StyxWoW.Me.Copper) > Int32.MaxValue) return;
            // fill rest data
            data["apikey"] = BuddyConSettings.Instance.apikey;
            data["name"] = Styx.StyxWoW.Me.Name.ToString();
            data["level"] = Convert.ToInt32(Styx.StyxWoW.Me.Level).ToString();
            data["xp"] = Convert.ToInt32(Styx.StyxWoW.Me.Experience).ToString();
            data["xp_needed"] = Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience).ToString();
            data["gold"] = Convert.ToInt32(Styx.StyxWoW.Me.Copper).ToString();
            data["nodeh"] = JSON.JsonEncode(Bots.Gatherbuddy.GatherbuddyBot.NodeCollectionCount);
            data["runningtime"] = Convert.ToInt32(Bots.ArchaeologyBuddy.ArchBuddy.runningTime.TotalSeconds).ToString();


            string[] sendParam = new string[data.Count+1];
            string[] sendVal = new string[data.Count+1];
            int i = 0;
            foreach (var pair in data)
            {
                sendParam[i] = pair.Key;
                sendVal[i] = pair.Value;
                i++;
            }
            sendParam[i] = "status";
            sendVal[i] = JSON.JsonEncode(status);
            status.Clear();


            //string response = Util.HttpPost("http://localhost/bc/index.php?r=api", sendParam, sendVal);
            string response = Util.HttpPost("http://buddycon.eu/index.php?r=api", sendParam, sendVal);

            Hashtable resJson = (Hashtable)JSON.JsonDecode(response);

            switch ((string)resJson["response"])
            {
                case "":
                    break;
                case "success":
                    break;
                case "screen":
                    screenie();
                    break;
                case "chat":
                    sendChat((string)resJson["type"], (string)resJson["message"], (string)resJson["to"]);
                    break;
                case "stophb":
                    Styx.CommonBot.TreeRoot.Stop();
                    break;
                case "starthb":
                    Styx.CommonBot.TreeRoot.Start();
                    break;
                default:
                    Logging.Write(string.Format("[bC]2:  {0}", response));
                    break;

            }

            data["name"] = "";
            data["nodeh"] = "";
            data["level"] = "";
            data["xp"]          = "";
            data["xp_needed"]   = "";
            data["chat_message"]= "";
            data["chat_type"]   = "";
            data["chat_from"]   = "";
            data["screen"]      = "";
            data["runningtime"] = "";
            
        }

        private void sendChat(string type, string message, string to)
        {
            Lua.DoString("SendChatMessage(\""+message+"\", \""+type+"\", nil, \""+to+"\");");
            Logging.Write(string.Format("[bC]: send Chat Channel: {0} Message: {1} To:{2}", type,message,to));
            
        }
    }
}
