﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using Styx.Helpers;
using Styx.Common;
using Styx;
using DefaultValue = Styx.Helpers.DefaultValueAttribute;

namespace BuddyCon{
    public class BuddyConSettings : Settings
    {
        private static BuddyConSettings _instance;

        public BuddyConSettings()
            : base(Path.Combine(Path.Combine(Styx.Helpers.GlobalSettings.SettingsDirectory, "Settings"), string.Format("BudyConSettings_{0}.xml", StyxWoW.Me.Name)))
        {

        }

        public static BuddyConSettings Instance { get { return _instance ?? (_instance = new BuddyConSettings()); } }

        #region Category: General

        [Setting]
        [Category("General")]
        [DisplayName("API Key")]
        public string apikey { get; set; }

        [Setting]
        [Category("General")]
        [DisplayName("Wow Dir")]
        [Description("Wow dir is needed for screenshots")]
        public string wowdir { get; set; }

        [Setting]
        [Category("General")]
        [DisplayName("Upload Script")]
        [Description("Url to your upload script on your webhost. If not set imgur will be used")]
        public string scripturl { get; set; }

        [Setting]
        [Category("General")]
        [DefaultValue("")]
        [DisplayName("Prowl Api Key")]
        public string prowlapi { get; set; }

        #endregion  
        
        #region Category: Notifications

        [Setting]
        [Category("Screenshot On")]
        [DefaultValue(false)]
        [DisplayName("Chat")]
        public Boolean scChat { get; set; }

        [Setting]
        [Category("Screenshot On")]
        [DefaultValue(false)]
        [DisplayName("Died")]
        public Boolean scDied { get; set; }

        [Setting]
        [Category("Screenshot On")]
        [DefaultValue(false)]
        [DisplayName("Level up")]
        public Boolean scLevel { get; set; }

        #endregion
    }

}
